<template>
  <div class="energy-map rounded-md overflow-hidden relative">
    <div
      class="absolute top-4 left-4 z-10 px-3 py-2 bg-white rounded-md shadow w-[300px] flex items-center"
    >
      <img
        :src="require('~/assets/images/magnifying-glass (2) 1.svg')"
        alt="magnifying-glass (2) 1.svg"
      />

      <input
        v-model="search"
        type="text"
        placeholder="Search..."
        class="p-0 w-full text-black focus:outline-none ml-3"
        @input="searchMap"
      />
    </div>

    <div
      class="type absolute inset-x-0 mx-auto bottom-4 z-10 font-semibold flex justify-center pointer-events-none"
    >
      <div class="px-5 py-2 rounded-l-3xl bg-yellow">ไฟถูกเปิด</div>

      <div class="px-5 py-2 bg-grey rounded-r-3xl">ไฟถูกปิด</div>

      <!-- <div class="px-5 py-2 rounded-r-3xl bg-orange">ออฟไลน์</div> -->
    </div>

    <div id="map" class="h-full"></div>
  </div>
</template>

<script>
import _ from "lodash";
import { Loader } from "@googlemaps/js-api-loader";

export default {
  props: {
    map_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selected_place: {
      type: Object,
      default: () => {
        return {};
      },
    },
    selectPlace: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      map: null,
      markers: [],
      info_windows: [],
      center: {
        lat: 13.736717,
        lng: 100.523186,
      },
      search: "",
    };
  },
  mounted() {
    this.setMap();
  },
  methods: {
    setMap() {
      const loader = new Loader({
        apiKey: process.env.g_map_api_key,
        version: "weekly",
      });

      loader.load().then(() => {
        this.map = new google.maps.Map(document.getElementById("map"), {
          center: this.center,
          zoom: 18,
          fullscreenControl: false,
          mapTypeControl: false,
          streetViewControl: false,
          mapTypeId: "satellite",
        });

        this.setMarker();
        this.searchMap();
      });
    },
    setMarker() {
      _.forEach(this.map_data, (d) => {
        const content_string = `
        <div class="p-4 font-kanit">
          <div class="text-xl font-semibold text-primary">${d.name}</div>
          <div class="text-xl ${
            d.status === false
              ? "text-orange"
              : d.status === true
              ? "text-yellow"
              : "text-grey"
          }">${
          d.status === false
            ? "ออฟไลน์"
            : d.status === true
            ? "ไฟถูกเปิด"
            : "ไฟถูกปิด"
        }</div>
          <div class="mt-4">ชื่อสถานที่: ${d.position.name}</div>
          <div>${d.position.address}</div>
          <div>ละติจูด: ${d.position.lat}</div>
          <div>ลองจิจูด: ${d.position.lng}</div>
        </div>
        `;

        const info_window = new google.maps.InfoWindow({
          raw_data: d,
          content: content_string,
        });

        const marker = new google.maps.Marker({
          raw_data: d,
          position: new google.maps.LatLng(d.position.lat, d.position.lng),
          icon:
            d.status === false
              ? require("~/assets/images/Group 1055.svg")
              : d.status === true
              ? require("~/assets/images/Group 1055.svg")
              : require("~/assets/images/Group 1055.svg"),
          map: this.map,
        });

        this.markers.push(marker);
        this.info_windows.push(info_window);

        marker.addListener("click", ({ domEvent, latLng }) => {
          this.selectPlace(marker.raw_data);
          this.selectMarker(marker, info_window);
        });
      });
    },
    selectMarker(marker, info_window) {
      _.forEach(this.info_windows, (w) => {
        w.close();
      });

      info_window.open({ anchor: marker, map: this.map });
    },
    searchMap: _.debounce(function () {
      const filter_markers = _.filter(this.markers, (m) =>
        m.raw_data.name.includes(this.search)
      );

      const markers = filter_markers.length > 0 ? filter_markers : this.markers;

      if (markers.length > 0) {
        const bounds = new google.maps.LatLngBounds();

        _.forEach(markers, (m) => {
          if (m.getVisible()) bounds.extend(m.getPosition());
        });

        this.map.fitBounds(bounds);
      }
    }, 200),
  },
};
</script>

<style lang="scss" scoped>
.energy-map {
  :deep() {
    .gm-style-iw {
      background: rgba(11, 29, 49, 1);
      padding: 0;
      height: 200px;
      width: 300px;
      .gm-style-iw-d {
        padding: 0;
      }
      > {
        button {
          top: 0 !important;
          right: 0 !important;
        }
      }
    }
    .gm-style-iw-tc::after {
      background: rgba(11, 29, 49, 1);
    }
    .gm-style-iw-d::-webkit-scrollbar-track-piece {
      background: rgba(11, 29, 49, 1);
    }
    .gm-ui-hover-effect > span {
      background: white;
    }
  }
}
</style>
